<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Esempio di contatore di accessi (vers. 2)</title>
<style type="text/css">
<!--
.Stile1 {
	font-family: Verdana;
	font-weight: bold;
}
-->
</style>
<?php

	// se il file esiste...
	if (file_exists("./naccessi.txt"))  
	{
	   // legge il numero di accessi finora effettuato
	   $fl = fopen("./naccessi.txt","r");
	   flock($fl,LOCK_EX);     // vd. commenti sottostantij
	   $n = fread($fl,filesize("./naccessi.txt"));
   	   flock($fl,LOCK_UN);	   // vd. commenti sottostanti
	   fclose($fl);
	}   
	else
	{
	   $n = 0;   // nessun accesso e' stato effettuato
	}

    // se esiste un cookie (non scaduto) con quel nome 
	// (e' quindi presente una chiave con lo stesso nome del vettore
	//  superglobal $_COOKIE) allora...
    if (! array_key_exists('acceduto_sito',$_COOKIE))
	{
	    // a scopo dimostrativo - questa istruzione di PHP setta il tempo 
		// di vita del cookie a 100 secondi, cosi' che si possa valutare 
		// l'effetto dello  scadere dello stesso
  	    setcookie("acceduto_sito","true",time() + 100);
   	
		$n++;    // incrementa il numero di accessi di uno
				
	    // registra il nuovo valore di accessi
		$fl = fopen("./naccessi.txt","w");
		flock($fl,LOCK_EX);    // opzionali - servono per evitare operazioni sovrapposte sul file
		                       // (possibili soprattutto in caso di forte traffico sul sito)
		fwrite($fl, $n);
		flock($fl,LOCK_UN);	   // opzionali - servono per evitare operazioni sovrapposte sul file
		                       // (possibili soprattutto in caso di forte traffico sul sito)		
		fclose($fl);					
	   
	}

	  // ...altrimenti il cookie esiste e quindi non si effettua il conteggio dell'accesso
?>
</head>

<body>
<p>&nbsp;</p>
<hr />
<!-- indica il numero di accessi sulla pagina -->
<p class="Stile1">Si è acceduto alla pagina  <?php echo $n; ?>&nbsp;&nbsp;volte </p>
<hr />
</body>
</html>
